#!/bin/bash

# Copyright (C) 2015 Deepin Technology Co., Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

GEN_NM_SETTING_CONST_FILE=../nm_setting_const_gen.go

if [ ! -d /usr/include/libnm ]; then
    echo "please install libnm-dev and retry"
    exit 1
fi

echo "// This file is automatically generated, please don't edit manually." > ${GEN_NM_SETTING_CONST_FILE}
echo -e "package network\n" >> ${GEN_NM_SETTING_CONST_FILE}
for f in /usr/include/libnm/nm-setting*.h; do
  echo "// $f";
  echo "const (";
  grep '^#define.*".*"' "$f" | awk '{print $2,"=",$3}';
  echo -e ")\n";
done >> ${GEN_NM_SETTING_CONST_FILE}
gofmt -w ${GEN_NM_SETTING_CONST_FILE}

echo "GEN ${GEN_NM_SETTING_CONST_FILE}"
